-- =============================================
-- SaveToDB Framework for Microsoft SQL Server
-- Version 9.0, February 5, 2019
--
-- This script upgrades SaveToDB Framework 9.1a to SaveToDB Framework 9.0
--
-- Copyright 2011-2020 Gartle LLC
-- =============================================

ALTER TABLE xls.workbooks ADD TABLE_SCHEMA nvarchar(128) NULL;
GO

UPDATE xls.handlers SET HANDLER_CODE = 'Actions, Change, ContextMenu, DoubleClick, SelectionChange, ConvertFormulas, DoNotConvertFormulas, DoNotSelect, DoNotSave, DoNotChange, DoNotAddValidation, DoNotAddChangeHandler, ProtectRows, Formula, FormulaValue, ParameterValues, ValidationList, SelectionList, SyncParameter, DefaultListObject, ManyToMany, DoNotAddManyToMany, AddStateColumn, KeepFormulas, DoNotKeepFormulas, UpdateEntireRow, UpdateChangedCellsOnly' WHERE TABLE_SCHEMA = 'xls' AND TABLE_NAME = 'handlers' AND COLUMN_NAME = 'EVENT_NAME' AND EVENT_NAME = 'ValidationList';
GO

UPDATE xls.handlers SET HANDLER_NAME = 'SaveToDB Online Help', HANDLER_CODE = REPLACE(HANDLER_CODE, '/savetodb8/', '/savetodb/') WHERE HANDLER_SCHEMA = 'xls' AND HANDLER_TYPE = 'HTTP' AND HANDLER_NAME = 'Online Help'
GO

INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'formats', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-tables.htm#xls.formats', NULL, 12, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'handlers', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-tables.htm#xls.handlers', NULL, 12, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'objects', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-tables.htm#xls.objects', NULL, 12, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'translations', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-tables.htm#xls.translations', NULL, 12, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'workbooks', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-tables.htm#xls.workbooks', NULL, 12, NULL);
GO

DELETE FROM xls.formats WHERE TABLE_SCHEMA = 'xls' AND TABLE_NAME IN ('objects', 'handlers', 'translations', 'workbooks', 'formats');

INSERT INTO xls.formats (TABLE_SCHEMA, TABLE_NAME, TABLE_EXCEL_FORMAT_XML) VALUES (N'xls', N'objects', N'<table name="xls.objects"><columnFormats><column name="" property="ListObjectName" value="objects" type="String" /><column name="" property="ShowTotals" value="False" type="Boolean" /><column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String" /><column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean" /><column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean" /><column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean" /><column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean" /><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="_RowNum" property="Address" value="$B$4" type="String" /><column name="_RowNum" property="NumberFormat" value="General" type="String" /><column name="_RowNum" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="ID" property="Address" value="$C$4" type="String" /><column name="ID" property="NumberFormat" value="General" type="String" /><column name="ID" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="Validation.Type" value="1" type="Double" /><column name="ID" property="Validation.Operator" value="1" type="Double" /><column name="ID" property="Validation.Formula1" value="-2147483648" type="String" /><column name="ID" property="Validation.Formula2" value="2147483647" type="String" /><column name="ID" property="Validation.AlertStyle" value="1" type="Double" /><column name="ID" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="ID" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="ID" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="ID" property="Validation.ErrorMessage" value="The column requires values of the int datatype." type="String" /><column name="ID" property="Validation.ShowInput" value="True" type="Boolean" /><column name="ID" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_SCHEMA" property="Address" value="$D$4" type="String" /><column name="TABLE_SCHEMA" property="ColumnWidth" value="16.57" type="Double" /><column name="TABLE_SCHEMA" property="NumberFormat" value="General" type="String" /><column name="TABLE_SCHEMA" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Type" value="6" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Operator" value="8" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Formula1" value="128" type="String" /><column name="TABLE_SCHEMA" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_SCHEMA" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TABLE_SCHEMA" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TABLE_SCHEMA" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_NAME" property="Address" value="$E$4" type="String" /><column name="TABLE_NAME" property="ColumnWidth" value="20.71" type="Double" /><column name="TABLE_NAME" property="NumberFormat" value="General" type="String" /><column name="TABLE_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_NAME" property="Validation.Type" value="6" type="Double" /><column name="TABLE_NAME" property="Validation.Operator" value="8" type="Double" /><column name="TABLE_NAME" property="Validation.Formula1" value="128" type="String" /><column name="TABLE_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TABLE_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TABLE_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_TYPE" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_TYPE" property="Address" value="$F$4" type="String" /><column name="TABLE_TYPE" property="ColumnWidth" value="13.14" type="Double" /><column name="TABLE_TYPE" property="NumberFormat" value="General" type="String" /><column name="TABLE_TYPE" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_TYPE" property="Validation.Type" value="3" type="Double" /><column name="TABLE_TYPE" property="Validation.Operator" value="1" type="Double" /><column name="TABLE_TYPE" property="Validation.Formula1" value="TABLE; VIEW; PROCEDURE; CODE; HTTP; TEXT; HIDDEN" type="String" /><column name="TABLE_TYPE" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_TYPE" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_TYPE" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_TYPE" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_TYPE" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_CODE" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_CODE" property="Address" value="$G$4" type="String" /><column name="TABLE_CODE" property="ColumnWidth" value="13.71" type="Double" /><column name="TABLE_CODE" property="NumberFormat" value="General" type="String" /><column name="TABLE_CODE" property="VerticalAlignment" value="-4160" type="Double" /><column name="INSERT_OBJECT" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="INSERT_OBJECT" property="Address" value="$H$4" type="String" /><column name="INSERT_OBJECT" property="ColumnWidth" value="27.86" type="Double" /><column name="INSERT_OBJECT" property="NumberFormat" value="General" type="String" /><column name="INSERT_OBJECT" property="VerticalAlignment" value="-4160" type="Double" /><column name="UPDATE_OBJECT" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="UPDATE_OBJECT" property="Address" value="$I$4" type="String" /><column name="UPDATE_OBJECT" property="ColumnWidth" value="27.86" type="Double" /><column name="UPDATE_OBJECT" property="NumberFormat" value="General" type="String" /><column name="UPDATE_OBJECT" property="VerticalAlignment" value="-4160" type="Double" /><column name="DELETE_OBJECT" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="DELETE_OBJECT" property="Address" value="$J$4" type="String" /><column name="DELETE_OBJECT" property="ColumnWidth" value="27.86" type="Double" /><column name="DELETE_OBJECT" property="NumberFormat" value="General" type="String" /><column name="DELETE_OBJECT" property="VerticalAlignment" value="-4160" type="Double" /><column name="SortFields(1)" property="KeyfieldName" value="TABLE_SCHEMA" type="String" /><column name="SortFields(1)" property="SortOn" value="0" type="Double" /><column name="SortFields(1)" property="Order" value="1" type="Double" /><column name="SortFields(1)" property="DataOption" value="0" type="Double" /><column name="SortFields(2)" property="KeyfieldName" value="TABLE_NAME" type="String" /><column name="SortFields(2)" property="SortOn" value="0" type="Double" /><column name="SortFields(2)" property="Order" value="1" type="Double" /><column name="SortFields(2)" property="DataOption" value="0" type="Double" /><column name="" property="Tab.Color" value="10498160" type="Double" /><column name="" property="Tab.Color" value="10498160" type="Double" /><column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean" /><column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean" /><column name="" property="ActiveWindow.Split" value="True" type="Boolean" /><column name="" property="ActiveWindow.SplitRow" value="0" type="Double" /><column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double" /><column name="" property="PageSetup.Orientation" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesWide" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesTall" value="1" type="Double" /></columnFormats></table>');
INSERT INTO xls.formats (TABLE_SCHEMA, TABLE_NAME, TABLE_EXCEL_FORMAT_XML) VALUES (N'xls', N'handlers', N'<table name="xls.handlers"><columnFormats><column name="" property="ListObjectName" value="handlers" type="String" /><column name="" property="ShowTotals" value="False" type="Boolean" /><column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String" /><column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean" /><column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean" /><column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean" /><column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean" /><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="_RowNum" property="Address" value="$B$4" type="String" /><column name="_RowNum" property="NumberFormat" value="General" type="String" /><column name="_RowNum" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="ID" property="Address" value="$C$4" type="String" /><column name="ID" property="NumberFormat" value="General" type="String" /><column name="ID" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="Validation.Type" value="1" type="Double" /><column name="ID" property="Validation.Operator" value="1" type="Double" /><column name="ID" property="Validation.Formula1" value="-2147483648" type="String" /><column name="ID" property="Validation.Formula2" value="2147483647" type="String" /><column name="ID" property="Validation.AlertStyle" value="1" type="Double" /><column name="ID" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="ID" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="ID" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="ID" property="Validation.ErrorMessage" value="The column requires values of the int datatype." type="String" /><column name="ID" property="Validation.ShowInput" value="True" type="Boolean" /><column name="ID" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_SCHEMA" property="Address" value="$D$4" type="String" /><column name="TABLE_SCHEMA" property="ColumnWidth" value="16.57" type="Double" /><column name="TABLE_SCHEMA" property="NumberFormat" value="General" type="String" /><column name="TABLE_SCHEMA" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Type" value="6" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Operator" value="8" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Formula1" value="20" type="String" /><column name="TABLE_SCHEMA" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_SCHEMA" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TABLE_SCHEMA" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(20) datatype." type="String" /><column name="TABLE_SCHEMA" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_NAME" property="Address" value="$E$4" type="String" /><column name="TABLE_NAME" property="ColumnWidth" value="14.43" type="Double" /><column name="TABLE_NAME" property="NumberFormat" value="General" type="String" /><column name="TABLE_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_NAME" property="Validation.Type" value="6" type="Double" /><column name="TABLE_NAME" property="Validation.Operator" value="8" type="Double" /><column name="TABLE_NAME" property="Validation.Formula1" value="128" type="String" /><column name="TABLE_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TABLE_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TABLE_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="COLUMN_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="COLUMN_NAME" property="Address" value="$F$4" type="String" /><column name="COLUMN_NAME" property="ColumnWidth" value="17.43" type="Double" /><column name="COLUMN_NAME" property="NumberFormat" value="General" type="String" /><column name="COLUMN_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="COLUMN_NAME" property="Validation.Type" value="6" type="Double" /><column name="COLUMN_NAME" property="Validation.Operator" value="8" type="Double" /><column name="COLUMN_NAME" property="Validation.Formula1" value="128" type="String" /><column name="COLUMN_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="COLUMN_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="COLUMN_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="COLUMN_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="COLUMN_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="COLUMN_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="COLUMN_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="EVENT_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="EVENT_NAME" property="Address" value="$G$4" type="String" /><column name="EVENT_NAME" property="ColumnWidth" value="21.57" type="Double" /><column name="EVENT_NAME" property="NumberFormat" value="General" type="String" /><column name="EVENT_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="EVENT_NAME" property="Validation.Type" value="3" type="Double" /><column name="EVENT_NAME" property="Validation.Operator" value="1" type="Double" /><column name="EVENT_NAME" property="Validation.Formula1" value="=INDIRECT(&quot;vl_xls_handlers_event_name&quot;)" type="String" /><column name="EVENT_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="EVENT_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="EVENT_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="EVENT_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="EVENT_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="HANDLER_SCHEMA" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="HANDLER_SCHEMA" property="Address" value="$H$4" type="String" /><column name="HANDLER_SCHEMA" property="ColumnWidth" value="19.71" type="Double" /><column name="HANDLER_SCHEMA" property="NumberFormat" value="General" type="String" /><column name="HANDLER_SCHEMA" property="VerticalAlignment" value="-4160" type="Double" /><column name="HANDLER_SCHEMA" property="Validation.Type" value="6" type="Double" /><column name="HANDLER_SCHEMA" property="Validation.Operator" value="8" type="Double" /><column name="HANDLER_SCHEMA" property="Validation.Formula1" value="20" type="String" /><column name="HANDLER_SCHEMA" property="Validation.AlertStyle" value="1" type="Double" /><column name="HANDLER_SCHEMA" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="HANDLER_SCHEMA" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="HANDLER_SCHEMA" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="HANDLER_SCHEMA" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(20) datatype." type="String" /><column name="HANDLER_SCHEMA" property="Validation.ShowInput" value="True" type="Boolean" /><column name="HANDLER_SCHEMA" property="Validation.ShowError" value="True" type="Boolean" /><column name="HANDLER_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="HANDLER_NAME" property="Address" value="$I$4" type="String" /><column name="HANDLER_NAME" property="ColumnWidth" value="31.14" type="Double" /><column name="HANDLER_NAME" property="NumberFormat" value="General" type="String" /><column name="HANDLER_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="HANDLER_NAME" property="Validation.Type" value="6" type="Double" /><column name="HANDLER_NAME" property="Validation.Operator" value="8" type="Double" /><column name="HANDLER_NAME" property="Validation.Formula1" value="128" type="String" /><column name="HANDLER_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="HANDLER_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="HANDLER_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="HANDLER_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="HANDLER_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="HANDLER_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="HANDLER_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="HANDLER_TYPE" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="HANDLER_TYPE" property="Address" value="$J$4" type="String" /><column name="HANDLER_TYPE" property="ColumnWidth" value="16.29" type="Double" /><column name="HANDLER_TYPE" property="NumberFormat" value="General" type="String" /><column name="HANDLER_TYPE" property="VerticalAlignment" value="-4160" type="Double" /><column name="HANDLER_TYPE" property="Validation.Type" value="3" type="Double" /><column name="HANDLER_TYPE" property="Validation.Operator" value="1" type="Double" /><column name="HANDLER_TYPE" property="Validation.Formula1" value="TABLE; VIEW; PROCEDURE; FUNCTION; CODE; HTTP; TEXT; MACRO; CMD; VALUES; RANGE; REFRESH; MENUSEPARATOR; PDF; REPORT; SHOWSHEETS; HIDESHEETS; SELECTSHEET" type="String" /><column name="HANDLER_TYPE" property="Validation.AlertStyle" value="1" type="Double" /><column name="HANDLER_TYPE" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="HANDLER_TYPE" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="HANDLER_TYPE" property="Validation.ShowInput" value="True" type="Boolean" /><column name="HANDLER_TYPE" property="Validation.ShowError" value="True" type="Boolean" /><column name="HANDLER_CODE" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="HANDLER_CODE" property="Address" value="$K$4" type="String" /><column name="HANDLER_CODE" property="ColumnWidth" value="70.71" type="Double" /><column name="HANDLER_CODE" property="NumberFormat" value="General" type="String" /><column name="HANDLER_CODE" property="VerticalAlignment" value="-4160" type="Double" /><column name="TARGET_WORKSHEET" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TARGET_WORKSHEET" property="Address" value="$L$4" type="String" /><column name="TARGET_WORKSHEET" property="ColumnWidth" value="21.71" type="Double" /><column name="TARGET_WORKSHEET" property="NumberFormat" value="General" type="String" /><column name="TARGET_WORKSHEET" property="VerticalAlignment" value="-4160" type="Double" /><column name="TARGET_WORKSHEET" property="Validation.Type" value="6" type="Double" /><column name="TARGET_WORKSHEET" property="Validation.Operator" value="8" type="Double" /><column name="TARGET_WORKSHEET" property="Validation.Formula1" value="128" type="String" /><column name="TARGET_WORKSHEET" property="Validation.AlertStyle" value="1" type="Double" /><column name="TARGET_WORKSHEET" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TARGET_WORKSHEET" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TARGET_WORKSHEET" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TARGET_WORKSHEET" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TARGET_WORKSHEET" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TARGET_WORKSHEET" property="Validation.ShowError" value="True" type="Boolean" /><column name="MENU_ORDER" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="MENU_ORDER" property="Address" value="$M$4" type="String" /><column name="MENU_ORDER" property="ColumnWidth" value="15.43" type="Double" /><column name="MENU_ORDER" property="NumberFormat" value="General" type="String" /><column name="MENU_ORDER" property="VerticalAlignment" value="-4160" type="Double" /><column name="MENU_ORDER" property="Validation.Type" value="1" type="Double" /><column name="MENU_ORDER" property="Validation.Operator" value="1" type="Double" /><column name="MENU_ORDER" property="Validation.Formula1" value="-2147483648" type="String" /><column name="MENU_ORDER" property="Validation.Formula2" value="2147483647" type="String" /><column name="MENU_ORDER" property="Validation.AlertStyle" value="1" type="Double" /><column name="MENU_ORDER" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="MENU_ORDER" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="MENU_ORDER" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="MENU_ORDER" property="Validation.ErrorMessage" value="The column requires values of the int datatype." type="String" /><column name="MENU_ORDER" property="Validation.ShowInput" value="True" type="Boolean" /><column name="MENU_ORDER" property="Validation.ShowError" value="True" type="Boolean" /><column name="EDIT_PARAMETERS" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="EDIT_PARAMETERS" property="Address" value="$N$4" type="String" /><column name="EDIT_PARAMETERS" property="ColumnWidth" value="19.57" type="Double" /><column name="EDIT_PARAMETERS" property="NumberFormat" value="General" type="String" /><column name="EDIT_PARAMETERS" property="HorizontalAlignment" value="-4108" type="Double" /><column name="EDIT_PARAMETERS" property="VerticalAlignment" value="-4160" type="Double" /><column name="EDIT_PARAMETERS" property="Font.Size" value="10" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).AppliesTo.Address" value="$N$4:$N$18" type="String" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).Type" value="6" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).Priority" value="2" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).ShowIconOnly" value="True" type="Boolean" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconSet.ID" value="8" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconCriteria(1).Type" value="3" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconCriteria(1).Operator" value="7" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconCriteria(2).Type" value="0" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconCriteria(2).Value" value="0.5" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconCriteria(2).Operator" value="7" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconCriteria(3).Type" value="0" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconCriteria(3).Value" value="1" type="Double" /><column name="EDIT_PARAMETERS" property="FormatConditions(1).IconCriteria(3).Operator" value="7" type="Double" /><column name="SortFields(1)" property="KeyfieldName" value="EVENT_NAME" type="String" /><column name="SortFields(1)" property="SortOn" value="0" type="Double" /><column name="SortFields(1)" property="Order" value="1" type="Double" /><column name="SortFields(1)" property="DataOption" value="0" type="Double" /><column name="SortFields(2)" property="KeyfieldName" value="TABLE_SCHEMA" type="String" /><column name="SortFields(2)" property="SortOn" value="0" type="Double" /><column name="SortFields(2)" property="Order" value="1" type="Double" /><column name="SortFields(2)" property="DataOption" value="0" type="Double" /><column name="SortFields(3)" property="KeyfieldName" value="TABLE_NAME" type="String" /><column name="SortFields(3)" property="SortOn" value="0" type="Double" /><column name="SortFields(3)" property="Order" value="1" type="Double" /><column name="SortFields(3)" property="DataOption" value="0" type="Double" /><column name="SortFields(4)" property="KeyfieldName" value="COLUMN_NAME" type="String" /><column name="SortFields(4)" property="SortOn" value="0" type="Double" /><column name="SortFields(4)" property="Order" value="1" type="Double" /><column name="SortFields(4)" property="DataOption" value="0" type="Double" /><column name="SortFields(5)" property="KeyfieldName" value="MENU_ORDER" type="String" /><column name="SortFields(5)" property="SortOn" value="0" type="Double" /><column name="SortFields(5)" property="Order" value="1" type="Double" /><column name="SortFields(5)" property="DataOption" value="0" type="Double" /><column name="SortFields(6)" property="KeyfieldName" value="HANDLER_SCHEMA" type="String" /><column name="SortFields(6)" property="SortOn" value="0" type="Double" /><column name="SortFields(6)" property="Order" value="1" type="Double" /><column name="SortFields(6)" property="DataOption" value="0" type="Double" /><column name="SortFields(7)" property="KeyfieldName" value="HANDLER_NAME" type="String" /><column name="SortFields(7)" property="SortOn" value="0" type="Double" /><column name="SortFields(7)" property="Order" value="1" type="Double" /><column name="SortFields(7)" property="DataOption" value="0" type="Double" /><column name="" property="Tab.Color" value="5287936" type="Double" /><column name="" property="Tab.Color" value="5287936" type="Double" /><column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean" /><column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean" /><column name="" property="ActiveWindow.Split" value="True" type="Boolean" /><column name="" property="ActiveWindow.SplitRow" value="0" type="Double" /><column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double" /><column name="" property="PageSetup.Orientation" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesWide" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesTall" value="1" type="Double" /></columnFormats></table>');
INSERT INTO xls.formats (TABLE_SCHEMA, TABLE_NAME, TABLE_EXCEL_FORMAT_XML) VALUES (N'xls', N'translations', N'<table name="xls.translations"><columnFormats><column name="" property="ListObjectName" value="translations" type="String" /><column name="" property="ShowTotals" value="False" type="Boolean" /><column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String" /><column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean" /><column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean" /><column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean" /><column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean" /><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="_RowNum" property="Address" value="$B$4" type="String" /><column name="_RowNum" property="NumberFormat" value="General" type="String" /><column name="_RowNum" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="ID" property="Address" value="$C$4" type="String" /><column name="ID" property="NumberFormat" value="General" type="String" /><column name="ID" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="Validation.Type" value="1" type="Double" /><column name="ID" property="Validation.Operator" value="1" type="Double" /><column name="ID" property="Validation.Formula1" value="-2147483648" type="String" /><column name="ID" property="Validation.Formula2" value="2147483647" type="String" /><column name="ID" property="Validation.AlertStyle" value="1" type="Double" /><column name="ID" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="ID" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="ID" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="ID" property="Validation.ErrorMessage" value="The column requires values of the int datatype." type="String" /><column name="ID" property="Validation.ShowInput" value="True" type="Boolean" /><column name="ID" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_SCHEMA" property="Address" value="$D$4" type="String" /><column name="TABLE_SCHEMA" property="ColumnWidth" value="16.57" type="Double" /><column name="TABLE_SCHEMA" property="NumberFormat" value="General" type="String" /><column name="TABLE_SCHEMA" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Type" value="6" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Operator" value="8" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Formula1" value="128" type="String" /><column name="TABLE_SCHEMA" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_SCHEMA" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TABLE_SCHEMA" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TABLE_SCHEMA" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_NAME" property="Address" value="$E$4" type="String" /><column name="TABLE_NAME" property="ColumnWidth" value="14.43" type="Double" /><column name="TABLE_NAME" property="NumberFormat" value="General" type="String" /><column name="TABLE_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_NAME" property="Validation.Type" value="6" type="Double" /><column name="TABLE_NAME" property="Validation.Operator" value="8" type="Double" /><column name="TABLE_NAME" property="Validation.Formula1" value="128" type="String" /><column name="TABLE_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TABLE_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TABLE_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="COLUMN_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="COLUMN_NAME" property="Address" value="$F$4" type="String" /><column name="COLUMN_NAME" property="ColumnWidth" value="17.43" type="Double" /><column name="COLUMN_NAME" property="NumberFormat" value="General" type="String" /><column name="COLUMN_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="COLUMN_NAME" property="Validation.Type" value="6" type="Double" /><column name="COLUMN_NAME" property="Validation.Operator" value="8" type="Double" /><column name="COLUMN_NAME" property="Validation.Formula1" value="128" type="String" /><column name="COLUMN_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="COLUMN_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="COLUMN_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="COLUMN_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="COLUMN_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="COLUMN_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="COLUMN_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="LANGUAGE_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="LANGUAGE_NAME" property="Address" value="$G$4" type="String" /><column name="LANGUAGE_NAME" property="ColumnWidth" value="19.57" type="Double" /><column name="LANGUAGE_NAME" property="NumberFormat" value="General" type="String" /><column name="LANGUAGE_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="LANGUAGE_NAME" property="Validation.Type" value="6" type="Double" /><column name="LANGUAGE_NAME" property="Validation.Operator" value="8" type="Double" /><column name="LANGUAGE_NAME" property="Validation.Formula1" value="2" type="String" /><column name="LANGUAGE_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="LANGUAGE_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="LANGUAGE_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="LANGUAGE_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="LANGUAGE_NAME" property="Validation.ErrorMessage" value="The column requires values of the char(2) datatype." type="String" /><column name="LANGUAGE_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="LANGUAGE_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="TRANSLATED_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TRANSLATED_NAME" property="Address" value="$H$4" type="String" /><column name="TRANSLATED_NAME" property="ColumnWidth" value="20.71" type="Double" /><column name="TRANSLATED_NAME" property="NumberFormat" value="General" type="String" /><column name="TRANSLATED_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="TRANSLATED_NAME" property="Validation.Type" value="6" type="Double" /><column name="TRANSLATED_NAME" property="Validation.Operator" value="8" type="Double" /><column name="TRANSLATED_NAME" property="Validation.Formula1" value="128" type="String" /><column name="TRANSLATED_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="TRANSLATED_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TRANSLATED_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TRANSLATED_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TRANSLATED_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TRANSLATED_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TRANSLATED_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="TRANSLATED_DESC" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TRANSLATED_DESC" property="Address" value="$I$4" type="String" /><column name="TRANSLATED_DESC" property="ColumnWidth" value="19.57" type="Double" /><column name="TRANSLATED_DESC" property="NumberFormat" value="General" type="String" /><column name="TRANSLATED_DESC" property="VerticalAlignment" value="-4160" type="Double" /><column name="TRANSLATED_DESC" property="Validation.Type" value="6" type="Double" /><column name="TRANSLATED_DESC" property="Validation.Operator" value="8" type="Double" /><column name="TRANSLATED_DESC" property="Validation.Formula1" value="1024" type="String" /><column name="TRANSLATED_DESC" property="Validation.AlertStyle" value="1" type="Double" /><column name="TRANSLATED_DESC" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TRANSLATED_DESC" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TRANSLATED_DESC" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TRANSLATED_DESC" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(1024) datatype." type="String" /><column name="TRANSLATED_DESC" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TRANSLATED_DESC" property="Validation.ShowError" value="True" type="Boolean" /><column name="TRANSLATED_COMMENT" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TRANSLATED_COMMENT" property="Address" value="$J$4" type="String" /><column name="TRANSLATED_COMMENT" property="ColumnWidth" value="25" type="Double" /><column name="TRANSLATED_COMMENT" property="NumberFormat" value="General" type="String" /><column name="TRANSLATED_COMMENT" property="VerticalAlignment" value="-4160" type="Double" /><column name="TRANSLATED_COMMENT" property="Validation.Type" value="6" type="Double" /><column name="TRANSLATED_COMMENT" property="Validation.Operator" value="8" type="Double" /><column name="TRANSLATED_COMMENT" property="Validation.Formula1" value="2000" type="String" /><column name="TRANSLATED_COMMENT" property="Validation.AlertStyle" value="1" type="Double" /><column name="TRANSLATED_COMMENT" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TRANSLATED_COMMENT" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TRANSLATED_COMMENT" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TRANSLATED_COMMENT" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(2000) datatype." type="String" /><column name="TRANSLATED_COMMENT" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TRANSLATED_COMMENT" property="Validation.ShowError" value="True" type="Boolean" /><column name="SortFields(1)" property="KeyfieldName" value="LANGUAGE_NAME" type="String" /><column name="SortFields(1)" property="SortOn" value="0" type="Double" /><column name="SortFields(1)" property="Order" value="1" type="Double" /><column name="SortFields(1)" property="DataOption" value="0" type="Double" /><column name="SortFields(2)" property="KeyfieldName" value="COLUMN_NAME" type="String" /><column name="SortFields(2)" property="SortOn" value="0" type="Double" /><column name="SortFields(2)" property="Order" value="1" type="Double" /><column name="SortFields(2)" property="DataOption" value="0" type="Double" /><column name="SortFields(3)" property="KeyfieldName" value="TABLE_SCHEMA" type="String" /><column name="SortFields(3)" property="SortOn" value="0" type="Double" /><column name="SortFields(3)" property="Order" value="1" type="Double" /><column name="SortFields(3)" property="DataOption" value="0" type="Double" /><column name="SortFields(4)" property="KeyfieldName" value="TABLE_NAME" type="String" /><column name="SortFields(4)" property="SortOn" value="0" type="Double" /><column name="SortFields(4)" property="Order" value="1" type="Double" /><column name="SortFields(4)" property="DataOption" value="0" type="Double" /><column name="" property="Tab.Color" value="6299648" type="Double" /><column name="" property="Tab.Color" value="6299648" type="Double" /><column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean" /><column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean" /><column name="" property="ActiveWindow.Split" value="True" type="Boolean" /><column name="" property="ActiveWindow.SplitRow" value="0" type="Double" /><column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double" /><column name="" property="PageSetup.Orientation" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesWide" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesTall" value="1" type="Double" /></columnFormats></table>');
INSERT INTO xls.formats (TABLE_SCHEMA, TABLE_NAME, TABLE_EXCEL_FORMAT_XML) VALUES (N'xls', N'workbooks', N'<table name="xls.workbooks"><columnFormats><column name="" property="ListObjectName" value="workbooks" type="String" /><column name="" property="ShowTotals" value="False" type="Boolean" /><column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String" /><column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean" /><column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean" /><column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean" /><column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean" /><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="_RowNum" property="Address" value="$B$4" type="String" /><column name="_RowNum" property="NumberFormat" value="General" type="String" /><column name="_RowNum" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="ID" property="Address" value="$C$4" type="String" /><column name="ID" property="NumberFormat" value="General" type="String" /><column name="ID" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="Validation.Type" value="1" type="Double" /><column name="ID" property="Validation.Operator" value="1" type="Double" /><column name="ID" property="Validation.Formula1" value="-2147483648" type="String" /><column name="ID" property="Validation.Formula2" value="2147483647" type="String" /><column name="ID" property="Validation.AlertStyle" value="1" type="Double" /><column name="ID" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="ID" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="ID" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="ID" property="Validation.ErrorMessage" value="The column requires values of the int datatype." type="String" /><column name="ID" property="Validation.ShowInput" value="True" type="Boolean" /><column name="ID" property="Validation.ShowError" value="True" type="Boolean" /><column name="NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="NAME" property="Address" value="$D$4" type="String" /><column name="NAME" property="ColumnWidth" value="21.71" type="Double" /><column name="NAME" property="NumberFormat" value="General" type="String" /><column name="NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="NAME" property="Validation.Type" value="6" type="Double" /><column name="NAME" property="Validation.Operator" value="8" type="Double" /><column name="NAME" property="Validation.Formula1" value="128" type="String" /><column name="NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="TEMPLATE" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TEMPLATE" property="Address" value="$E$4" type="String" /><column name="TEMPLATE" property="ColumnWidth" value="23.57" type="Double" /><column name="TEMPLATE" property="NumberFormat" value="General" type="String" /><column name="TEMPLATE" property="VerticalAlignment" value="-4160" type="Double" /><column name="TEMPLATE" property="Validation.Type" value="6" type="Double" /><column name="TEMPLATE" property="Validation.Operator" value="8" type="Double" /><column name="TEMPLATE" property="Validation.Formula1" value="255" type="String" /><column name="TEMPLATE" property="Validation.AlertStyle" value="1" type="Double" /><column name="TEMPLATE" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TEMPLATE" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TEMPLATE" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TEMPLATE" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(255) datatype." type="String" /><column name="TEMPLATE" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TEMPLATE" property="Validation.ShowError" value="True" type="Boolean" /><column name="DEFINITION" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="DEFINITION" property="Address" value="$F$4" type="String" /><column name="DEFINITION" property="ColumnWidth" value="70.71" type="Double" /><column name="DEFINITION" property="NumberFormat" value="General" type="String" /><column name="DEFINITION" property="VerticalAlignment" value="-4160" type="Double" /><column name="DEFINITION" property="WrapText" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_SCHEMA" property="Address" value="$G$4" type="String" /><column name="TABLE_SCHEMA" property="ColumnWidth" value="16.57" type="Double" /><column name="TABLE_SCHEMA" property="NumberFormat" value="General" type="String" /><column name="TABLE_SCHEMA" property="VerticalAlignment" value="-4160" type="Double" /><column name="SortFields(1)" property="KeyfieldName" value="TABLE_SCHEMA" type="String" /><column name="SortFields(1)" property="SortOn" value="0" type="Double" /><column name="SortFields(1)" property="Order" value="1" type="Double" /><column name="SortFields(1)" property="DataOption" value="0" type="Double" /><column name="SortFields(2)" property="KeyfieldName" value="NAME" type="String" /><column name="SortFields(2)" property="SortOn" value="0" type="Double" /><column name="SortFields(2)" property="Order" value="1" type="Double" /><column name="SortFields(2)" property="DataOption" value="0" type="Double" /><column name="" property="Tab.Color" value="15773696" type="Double" /><column name="" property="Tab.Color" value="15773696" type="Double" /><column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean" /><column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean" /><column name="" property="ActiveWindow.Split" value="True" type="Boolean" /><column name="" property="ActiveWindow.SplitRow" value="0" type="Double" /><column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double" /><column name="" property="PageSetup.Orientation" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesWide" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesTall" value="1" type="Double" /></columnFormats></table>');
INSERT INTO xls.formats (TABLE_SCHEMA, TABLE_NAME, TABLE_EXCEL_FORMAT_XML) VALUES (N'xls', N'formats', N'<table name="xls.formats"><columnFormats><column name="" property="ListObjectName" value="handlers" type="String" /><column name="" property="ShowTotals" value="False" type="Boolean" /><column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String" /><column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean" /><column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean" /><column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean" /><column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean" /><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="_RowNum" property="Address" value="$B$4" type="String" /><column name="_RowNum" property="NumberFormat" value="General" type="String" /><column name="_RowNum" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="EntireColumn.Hidden" value="True" type="Boolean" /><column name="ID" property="Address" value="$C$4" type="String" /><column name="ID" property="NumberFormat" value="General" type="String" /><column name="ID" property="VerticalAlignment" value="-4160" type="Double" /><column name="ID" property="Validation.Type" value="1" type="Double" /><column name="ID" property="Validation.Operator" value="1" type="Double" /><column name="ID" property="Validation.Formula1" value="-2147483648" type="String" /><column name="ID" property="Validation.Formula2" value="2147483647" type="String" /><column name="ID" property="Validation.AlertStyle" value="1" type="Double" /><column name="ID" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="ID" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="ID" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="ID" property="Validation.ErrorMessage" value="The column requires values of the int datatype." type="String" /><column name="ID" property="Validation.ShowInput" value="True" type="Boolean" /><column name="ID" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_SCHEMA" property="Address" value="$D$4" type="String" /><column name="TABLE_SCHEMA" property="ColumnWidth" value="16.57" type="Double" /><column name="TABLE_SCHEMA" property="NumberFormat" value="General" type="String" /><column name="TABLE_SCHEMA" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Type" value="6" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Operator" value="8" type="Double" /><column name="TABLE_SCHEMA" property="Validation.Formula1" value="128" type="String" /><column name="TABLE_SCHEMA" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_SCHEMA" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TABLE_SCHEMA" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TABLE_SCHEMA" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_SCHEMA" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_NAME" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_NAME" property="Address" value="$E$4" type="String" /><column name="TABLE_NAME" property="ColumnWidth" value="14.43" type="Double" /><column name="TABLE_NAME" property="NumberFormat" value="General" type="String" /><column name="TABLE_NAME" property="VerticalAlignment" value="-4160" type="Double" /><column name="TABLE_NAME" property="Validation.Type" value="6" type="Double" /><column name="TABLE_NAME" property="Validation.Operator" value="8" type="Double" /><column name="TABLE_NAME" property="Validation.Formula1" value="128" type="String" /><column name="TABLE_NAME" property="Validation.AlertStyle" value="1" type="Double" /><column name="TABLE_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.InCellDropdown" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String" /><column name="TABLE_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String" /><column name="TABLE_NAME" property="Validation.ShowInput" value="True" type="Boolean" /><column name="TABLE_NAME" property="Validation.ShowError" value="True" type="Boolean" /><column name="TABLE_EXCEL_FORMAT_XML" property="EntireColumn.Hidden" value="False" type="Boolean" /><column name="TABLE_EXCEL_FORMAT_XML" property="Address" value="$F$4" type="String" /><column name="TABLE_EXCEL_FORMAT_XML" property="ColumnWidth" value="70.71" type="Double" /><column name="TABLE_EXCEL_FORMAT_XML" property="NumberFormat" value="General" type="String" /><column name="TABLE_EXCEL_FORMAT_XML" property="VerticalAlignment" value="-4160" type="Double" /><column name="SortFields(1)" property="KeyfieldName" value="TABLE_SCHEMA" type="String" /><column name="SortFields(1)" property="SortOn" value="0" type="Double" /><column name="SortFields(1)" property="Order" value="1" type="Double" /><column name="SortFields(1)" property="DataOption" value="2" type="Double" /><column name="SortFields(2)" property="KeyfieldName" value="TABLE_NAME" type="String" /><column name="SortFields(2)" property="SortOn" value="0" type="Double" /><column name="SortFields(2)" property="Order" value="1" type="Double" /><column name="SortFields(2)" property="DataOption" value="2" type="Double" /><column name="" property="Tab.Color" value="5287936" type="Double" /><column name="" property="Tab.Color" value="5287936" type="Double" /><column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean" /><column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean" /><column name="" property="ActiveWindow.Split" value="True" type="Boolean" /><column name="" property="ActiveWindow.SplitRow" value="0" type="Double" /><column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double" /><column name="" property="PageSetup.Orientation" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesWide" value="1" type="Double" /><column name="" property="PageSetup.FitToPagesTall" value="1" type="Double" /></columnFormats></table>');
GO

DELETE FROM xls.workbooks WHERE NAME = N'savetodb9_configuration.xlsx';
GO

INSERT INTO xls.workbooks (NAME, TEMPLATE, DEFINITION, TABLE_SCHEMA) VALUES (N'savetodb_configuration.xlsx', NULL, N'objects=xls.objects,(Default),False,$B$3,,{"Parameters":{"TABLE_SCHEMA":null,"TABLE_TYPE":null},"ListObjectName":"objects"}
handlers=xls.handlers,(Default),False,$B$3,,{"Parameters":{"TABLE_SCHEMA":null,"EVENT_NAME":null,"HANDLER_TYPE":null},"ListObjectName":"handlers"}
translations=xls.translations,(Default),False,$B$3,,{"Parameters":{"TABLE_SCHEMA":null,"LANGUAGE_NAME":null},"ListObjectName":"translations"}
workbooks=xls.workbooks,(Default),False,$B$3,,{"Parameters":{},"ListObjectName":"workbooks"}', N'xls');
GO

INSERT INTO xls.workbooks (NAME, TEMPLATE, DEFINITION, TABLE_SCHEMA) VALUES (N'savetodb_developer.xlsx', NULL, N'objects=xls.objects,(Default),False,$B$3,,{"Parameters":{"TABLE_SCHEMA":null,"TABLE_TYPE":null},"ListObjectName":"objects","WorkbookLanguage":"en"}
handlers=xls.handlers,(Default),False,$B$3,,{"Parameters":{"TABLE_SCHEMA":null,"TABLE_NAME":null,"EVENT_NAME":null},"ListObjectName":"handlers","WorkbookLanguage":"en"}
translations=xls.translations,(Default),False,$B$3,,{"Parameters":{"TABLE_SCHEMA":null,"TABLE_NAME":null,"LANGUAGE_NAME":null},"ListObjectName":"translations","WorkbookLanguage":"en"}
all_translations=xls.view_all_translations,(Default),False,$B$3,,{"Parameters":{"TRANSLATION_TYPE":null,"TABLE_TYPE":null,"TABLE_SCHEMA":null,"LANGUAGE_NAME":"en"},"ListObjectName":"all_translations","WorkbookLanguage":"en"}
translation_pivot=xls.usp_translations,(Default),False,$B$3,,{"Parameters":{"field":"TRANSLATED_NAME"},"ListObjectName":"translation_pivot","WorkbookLanguage":"en"}
workbooks=xls.workbooks,(Default),False,$B$3,,{"Parameters":{"TABLE_SCHEMA":null},"ListObjectName":"workbooks","WorkbookLanguage":"en"}
primary_keys=xls.view_primary_keys,(Default),False,$B$3,,{"Parameters":{"SCHEMA":null},"ListObjectName":"primary_keys","WorkbookLanguage":"en"}
unique_keys=xls.view_unique_keys,(Default),False,$B$3,,{"Parameters":{"SCHEMA":null},"ListObjectName":"unique_keys","WorkbookLanguage":"en"}
foreign_keys=xls.view_foreign_keys,(Default),False,$B$3,,{"Parameters":{"SCHEMA":null},"ListObjectName":"foreign_keys","WorkbookLanguage":"en"}', N'xls');
GO

INSERT INTO xls.workbooks (NAME, TEMPLATE, DEFINITION, TABLE_SCHEMA) VALUES (N'savetodb_permissions.xlsx', NULL, N'database_permissions=xls.usp_database_permissions,(Default),False,$B$3,,{"Parameters":{},"ListObjectName":"database_permissions"}
principal_permissions=xls.usp_principal_permissions,(Default),False,$B$3,,{"Parameters":{"principal":null,"name":null,"has_any":1},"ListObjectName":"principal_permissions"}
object_permissions=xls.usp_object_permissions,(Default),False,$B$3,,{"Parameters":{"principal":null,"schema":null,"type":"","has_any":null,"has_direct":1},"ListObjectName":"object_permissions"}
role_members=xls.usp_role_members,(Default),False,$B$3,,{"Parameters":{},"ListObjectName":"role_members"}', N'xls');
GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Selects database permissions
-- =============================================

CREATE PROCEDURE [xls].[usp_database_permissions]
AS
BEGIN

SET NOCOUNT ON;

WITH cte (
    principal_id
    , [permission_name]
    , [state]
) AS (
    SELECT
        r.principal_id
        , p.[permission_name]
        , p.[state]
    FROM
        sys.database_principals r
        LEFT OUTER JOIN sys.database_permissions p ON p.grantee_principal_id = r.principal_id AND p.class = 0
    WHERE
        r.is_fixed_role = 0
        AND NOT r.[sid] IS NULL
        AND NOT r.name IN ('dbo')
)

SELECT
    LOWER(r.type_desc) AS principal_type
    , r.name AS principal
    , CASE p.[CONNECT]          WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [CONNECT]
    , CASE p.[SELECT]           WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [SELECT]
    , CASE p.[INSERT]           WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [INSERT]
    , CASE p.[UPDATE]           WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [UPDATE]
    , CASE p.[DELETE]           WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [DELETE]
    , CASE p.[EXECUTE]          WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [EXECUTE]
    , CASE p.[VIEW DEFINITION]  WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [VIEW DEFINITION]
    , CASE p.[REFERENCES]       WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [REFERENCES]
    , CASE p.[ALTER ANY SCHEMA] WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [ALTER ANY SCHEMA]
    , CASE p.[CREATE SCHEMA]    WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [CREATE SCHEMA]
    , CASE p.[CREATE TABLE]     WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [CREATE TABLE]
    , CASE p.[CREATE VIEW]      WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [CREATE VIEW]
    , CASE p.[ALTER PROCEDURE] WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [ALTER PROCEDURE]
    , CASE p.[CREATE FUNCTION]  WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [CREATE FUNCTION]
    , CASE p.[ALTER ANY USER]   WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [ALTER ANY USER]
    , CASE p.[ALTER ANY ROLE]   WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [ALTER ANY ROLE]
    , CASE p.[CREATE ROLE]      WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [CREATE ROLE]
    , CASE p.[TAKE OWNERSHIP]   WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [TAKE OWNERSHIP]
    , CASE p.[ALTER]            WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [ALTER]
    , CASE p.[CONTROL]          WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [CONTROL]
FROM
    (
        SELECT
            t.principal_id
            , t.[permission_name]
            , CASE t.[state] WHEN 'D' THEN 43 WHEN 'W' THEN 42 WHEN 'G' THEN 41 ELSE NULL END AS state_mask
        FROM
            cte t
        UNION ALL
        SELECT
            u.principal_id
            , t.[permission_name]
            , CASE t.[state] WHEN 'D' THEN 33 WHEN 'W' THEN 32 WHEN 'G' THEN 31 ELSE NULL END AS state_mask
        FROM
            cte t
            INNER JOIN sys.database_role_members rm ON rm.role_principal_id = t.principal_id
            LEFT OUTER JOIN sys.database_principals u ON u.principal_id = rm.member_principal_id
        WHERE
            t.[permission_name] IS NOT NULL
    ) s PIVOT (
        MAX(state_mask)
        FOR [permission_name] IN (
            [CONNECT]
            , [SELECT], [INSERT], [UPDATE], [DELETE]
            , [EXECUTE]
            , [VIEW DEFINITION]
            , [REFERENCES]
            , [ALTER ANY SCHEMA], [CREATE SCHEMA]
            , [CREATE TABLE], [CREATE VIEW], [ALTER PROCEDURE], [CREATE FUNCTION]
            , [ALTER ANY USER]
            , [ALTER ANY ROLE], [CREATE ROLE]
            , [TAKE OWNERSHIP], [ALTER], [CONTROL]
            )
    ) p
    INNER JOIN sys.database_principals r ON r.principal_id = p.principal_id
ORDER BY
    r.[type]
    , r.name

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Cell change event handler for usp_database_permissions
-- =============================================

CREATE PROCEDURE [xls].[usp_database_permissions_change]
    @column_name nvarchar(128) = NULL
    , @cell_value int = NULL
    , @principal nvarchar(128) = NULL
AS
BEGIN

SET NOCOUNT ON

DECLARE @permission varchar(128)
DECLARE @authorization varchar(128)
DECLARE @options varchar(128) = ''

SET @permission = UPPER(@column_name)
SET @authorization = UPPER(@cell_value)

IF CHARINDEX('-' + @permission + '-',
    '-CONNECT-SELECT-INSERT-UPDATE-DELETE-EXECUTE-VIEW DEFINITION-REFERENCES-ALTER ANY SCHEMA-CREATE SCHEMA-CREATE TABLE-CREATE VIEW-ALTER PROCEDURE-CREATE FUNCTION-ALTER ANY USER-ALTER ANY ROLE-CREATE ROLE-TAKE OWNERSHIP-ALTER-CONTROL-') = 0
    RETURN

IF @authorization IS NULL
    SET @authorization = 'REVOKE'
ELSE IF @authorization = 'GRANT' OR @authorization = 'G'
    SET @authorization = 'GRANT'
ELSE IF @authorization = 'GRANT+' OR @authorization = 'G+'
    BEGIN
    SET @authorization = 'GRANT'
    SET @options      = ' WITH GRANT OPTION'
    END
ELSE IF @authorization = 'DENY' OR @authorization = 'D'
    SET @authorization = 'DENY'
ELSE IF @authorization = 'DENY+' OR @authorization = 'D+'
    BEGIN
    SET @authorization = 'DENY'
    SET @options      = ' CASCADE'
    END
ELSE IF @authorization = 'REVOKE' OR @authorization = 'R'
    SET @authorization = 'REVOKE'
ELSE IF @authorization = 'REVOKE-' OR @authorization = 'R-'
    SET @authorization = 'REVOKE GRANT OPTION FOR'
ELSE IF @authorization = 'REVOKE+' OR @authorization = 'R+'
    BEGIN
    SET @authorization = 'REVOKE'
    SET @options      = ' CASCADE'
    END
ELSE
    RETURN

DECLARE @query varchar(max)

SET @query = @authorization + ' ' + @permission + ' TO ' + QUOTENAME(@principal) + @options

EXEC (@query)

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Selects object permissions
-- =============================================

CREATE PROCEDURE [xls].[usp_object_permissions]
    @principal nvarchar(128) = NULL,
    @schema nvarchar(128) = NULL,
    @type nvarchar(128) = NULL,
    @has_any bit = NULL,
    @has_direct bit = NULL
AS
BEGIN

IF @type = '' SET @type = NULL

SET NOCOUNT ON;

WITH cte (
    [schema_id]
    , [object_id]
    , principal_id
    , [permission_name]
    , [state]
) AS (
    SELECT
        o.[schema_id]
        , o.[object_id]
        , r.principal_id
        , p.[permission_name]
        , p.[state]
    FROM
        sys.objects o
        INNER JOIN sys.schemas s ON s.[schema_id] = o.[schema_id]
        LEFT OUTER JOIN sys.extended_properties e ON e.major_id = o.[object_id]
        CROSS JOIN sys.database_principals r
        LEFT OUTER JOIN sys.database_permissions p ON o.[object_id] = p.major_id AND r.principal_id = p.grantee_principal_id AND p.class = 1
    WHERE
        o.[type] IN ('U', 'V', 'P', 'FN', 'IF')
        AND ISNULL(o.is_ms_shipped, 0) = 0
        AND NOT ISNULL(e.name, '') = 'microsoft_database_tools_support'
        AND r.is_fixed_role = 0
        AND NOT r.[sid] IS NULL
        AND NOT r.name IN ('dbo', 'guest', 'public')
    UNION ALL
    SELECT
        s.[schema_id]
        , NULL AS [object_id]
        , r.principal_id
        , p.[permission_name]
        , p.[state]
    FROM
        sys.schemas s
        INNER JOIN sys.database_principals e ON e.principal_id = s.principal_id
        CROSS JOIN sys.database_principals r
        LEFT OUTER JOIN sys.database_permissions p ON p.major_id = s.[schema_id] AND r.principal_id = p.grantee_principal_id AND p.class = 3
    WHERE
        r.is_fixed_role = 0
        AND NOT r.[sid] IS NULL
        AND NOT r.name IN ('dbo', 'guest', 'public')
        AND e.is_fixed_role = 0
        AND NOT e.[sid] IS NULL
        AND NOT s.name IN ('sys', 'guest', 'INFORMATION_SCHEMA')
    )

SELECT
    t.principal_type
    , t.principal
    , t.[schema]
    , t.name
    , t.[type]
    , t.has_any
    , t.has_direct
    , t.[SELECT]
    , t.[INSERT]
    , t.[UPDATE]
    , t.[DELETE]
    , t.[EXECUTE]
    , t.[VIEW DEFINITION]
    , t.[REFERENCES], [TAKE OWNERSHIP]
    , t.[ALTER]
    , t.[CONTROL]
FROM
    (
        SELECT
            LOWER(r.type_desc) AS principal_type
            , r.name AS principal
            , s.name AS [schema]
            , o.name
            , CASE o.[type]
                WHEN 'U'  THEN 'table'
                WHEN 'V'  THEN 'view'
                WHEN 'P'  THEN 'procedure'
                WHEN 'IF' THEN 'function'
                WHEN 'FN' THEN 'function'
                ELSE COALESCE(LOWER(o.type_desc), 'schema')
                END AS [type]
            , CASE WHEN COALESCE([SELECT], [INSERT], [UPDATE], [DELETE], [EXECUTE], [VIEW DEFINITION], [REFERENCES], [TAKE OWNERSHIP], [CONTROL], 0) = 0 THEN 0 ELSE 1 END AS has_any
            , CASE p.[SELECT]           WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[INSERT]           WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[UPDATE]           WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[DELETE]           WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[EXECUTE]          WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[VIEW DEFINITION]  WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[REFERENCES]       WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[TAKE OWNERSHIP]   WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[ALTER]            WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
              CASE p.[CONTROL]          WHEN 43 THEN 1 WHEN 42 THEN 1 WHEN 41 THEN 1 ELSE
                0 END END END END END END END END END END AS has_direct
            , CASE p.[SELECT]           WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [SELECT]
            , CASE p.[INSERT]           WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [INSERT]
            , CASE p.[UPDATE]           WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [UPDATE]
            , CASE p.[DELETE]           WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [DELETE]
            , CASE p.[EXECUTE]          WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [EXECUTE]
            , CASE p.[VIEW DEFINITION]  WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [VIEW DEFINITION]
            , CASE p.[REFERENCES]       WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [REFERENCES]
            , CASE p.[TAKE OWNERSHIP]   WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [TAKE OWNERSHIP]
            , CASE p.[ALTER]            WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [ALTER]
            , CASE p.[CONTROL]          WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' WHEN 23 THEN 'DENY s' WHEN 22 THEN 'GRANT+ s' WHEN 21 THEN 'GRANT s' WHEN 13 THEN 'DENY sr' WHEN 12 THEN 'GRANT+ sr' WHEN 11 THEN 'GRANT sr' ELSE NULL END AS [CONTROL]
            , CASE o.[type]
                WHEN 'U'  THEN 11
                WHEN 'V'  THEN 12
                WHEN 'P'  THEN 13
                WHEN 'IF' THEN 14
                WHEN 'FN' THEN 15
                ELSE CASE WHEN o.[type] IS NULL THEN 1 ELSE 21 END END AS type_order
        FROM
            (
                SELECT
                    t.[schema_id]
                    , t.[object_id]
                    , t.principal_id
                    , t.[permission_name]
                    , CASE t.[state] WHEN 'D' THEN 43 WHEN 'W' THEN 42 WHEN 'G' THEN 41 ELSE NULL END AS state_mask
                FROM
                    cte t
                UNION ALL
                SELECT
                    t.[schema_id]
                    , t.[object_id]
                    , u.principal_id
                    , t.[permission_name]
                    , CASE t.[state] WHEN 'D' THEN 33 WHEN 'W' THEN 32 WHEN 'G' THEN 31 ELSE NULL END AS state_mask
                FROM
                    cte t
                    INNER JOIN sys.database_role_members rm ON rm.role_principal_id = t.principal_id
                    LEFT OUTER JOIN sys.database_principals u ON u.principal_id = rm.member_principal_id
                WHERE
                    t.[permission_name] IS NOT NULL
                UNION ALL
                SELECT
                    t.[schema_id]
                    , o.[object_id]
                    , t.principal_id
                    , t.[permission_name]
                    , CASE t.[state] WHEN 'D' THEN 23 WHEN 'W' THEN 22 WHEN 'G' THEN 21 ELSE NULL END AS state_mask
                FROM
                    cte t
                    INNER JOIN sys.objects o ON o.[schema_id] = t.[schema_id]
                WHERE
                    t.[permission_name] IS NOT NULL
                    AND t.[object_id] IS NULL
                    AND o.[type] IN ('U', 'V', 'P', 'FN', 'IF')
                UNION ALL
                SELECT
                    t.[schema_id]
                    , o.[object_id]
                    , u.principal_id
                    , t.[permission_name]
                    , CASE t.[state] WHEN 'D' THEN 13 WHEN 'W' THEN 12 WHEN 'G' THEN 11 ELSE NULL END AS state_mask
                FROM
                    cte t
                    INNER JOIN sys.objects o ON o.[schema_id] = t.[schema_id]
                    INNER JOIN sys.database_role_members rm ON rm.role_principal_id = t.principal_id
                    LEFT OUTER JOIN sys.database_principals u ON u.principal_id = rm.member_principal_id
                WHERE
                    t.[permission_name] IS NOT NULL
                    AND t.[object_id] IS NULL
                    AND o.[type] IN ('U', 'V', 'P', 'FN', 'IF')
            ) s PIVOT (
                MAX(state_mask)
                FOR [permission_name] IN (
                    [SELECT], [INSERT], [UPDATE], [DELETE]
                    , [EXECUTE]
                    , [VIEW DEFINITION]
                    , [REFERENCES], [TAKE OWNERSHIP], [ALTER]
                    , [CONTROL]
                    )
            ) p
            INNER JOIN sys.schemas s ON s.[schema_id] = p.[schema_id]
            LEFT OUTER JOIN sys.objects o ON o.[object_id] = p.[object_id]
            INNER JOIN sys.database_principals r ON r.principal_id = p.principal_id
    ) t
WHERE
    COALESCE(t.principal, '') = COALESCE(@principal, t.principal, '')
    AND COALESCE(t.[schema], '') = COALESCE(@schema, t.[schema], '')
    AND COALESCE(t.[type], '') = COALESCE(@type, t.[type], '')
    AND COALESCE(t.has_any, -1) = COALESCE(CAST(@has_any AS int), t.has_any, -1)
    AND COALESCE(t.has_direct, -1) = COALESCE(CAST(@has_direct AS int), t.has_direct, -1)
ORDER BY
    t.principal_type
    , t.principal
    , t.[schema]
    , t.type_order
    , t.[type]
    , t.name

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Cell change event handler for usp_object_permissions
-- =============================================

CREATE PROCEDURE [xls].[usp_object_permissions_change]
    @column_name nvarchar(128) = NULL
    , @cell_value int = NULL
    , @principal nvarchar(128) = NULL
    , @schema nvarchar(128) = NULL
    , @name nvarchar(128) = NULL
AS
BEGIN

SET NOCOUNT ON

DECLARE @permission varchar(128)
DECLARE @authorization varchar(128)

SET @permission = UPPER(@column_name)
SET @authorization = UPPER(@cell_value)
DECLARE @options varchar(128) = ''

IF CHARINDEX('-' + @permission + '-',
    '-SELECT-INSERT-UPDATE-DELETE-EXECUTE-VIEW DEFINITION-REFERENCES-TAKE OWNERSHIP-ALTER-CONTROL-') = 0
    RETURN

IF @authorization IS NULL
    SET @authorization = 'REVOKE'
ELSE IF @authorization = 'GRANT' OR @authorization = 'G'
    SET @authorization = 'GRANT'
ELSE IF @authorization = 'GRANT+' OR @authorization = 'G+'
    BEGIN
    SET @authorization = 'GRANT'
    SET @options      = ' WITH GRANT OPTION'
    END
ELSE IF @authorization = 'DENY' OR @authorization = 'D'
    SET @authorization = 'DENY'
ELSE IF @authorization = 'DENY+' OR @authorization = 'D+'
    BEGIN
    SET @authorization = 'DENY'
    SET @options      = ' CASCADE'
    END
ELSE IF @authorization = 'REVOKE' OR @authorization = 'R'
    SET @authorization = 'REVOKE'
ELSE IF @authorization = 'REVOKE-' OR @authorization = 'R-'
    SET @authorization = 'REVOKE GRANT OPTION FOR'
ELSE IF @authorization = 'REVOKE+' OR @authorization = 'R+'
    BEGIN
    SET @authorization = 'REVOKE'
    SET @options      = ' CASCADE'
    END
ELSE
    RETURN

DECLARE @query varchar(max)

IF @name IS NULL
    SET @query = @authorization + ' ' + @permission + ' ON SCHEMA::' + QUOTENAME(@schema) + ' TO ' + QUOTENAME(@principal)
ELSE
    SET @query = @authorization + ' ' + @permission + ' ON OBJECT::' +
        QUOTENAME(@schema) + '.' + QUOTENAME(@name) + ' TO ' + QUOTENAME(@principal)

EXEC (@query)

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Selects object permissions
-- =============================================

CREATE PROCEDURE [xls].[usp_principal_permissions]
    @principal nvarchar(128) = NULL,
    @name nvarchar(128) = NULL,
    @has_any bit = NULL
AS
BEGIN

SET NOCOUNT ON;

WITH cte (
    principal_id
    , [user_id]
    , [permission_name]
    , [state]
) AS (
    SELECT
        r.principal_id
        , u.principal_id AS [user_id]
        , p.[permission_name]
        , p.[state]
    FROM
        sys.database_principals u
        CROSS JOIN sys.database_principals r
        LEFT OUTER JOIN sys.database_permissions p ON p.major_id = u.principal_id AND r.principal_id = p.grantee_principal_id AND p.class = 4
    WHERE
        r.is_fixed_role = 0
        AND NOT r.[sid] IS NULL
        AND NOT r.name IN ('guest', 'public')
        AND u.is_fixed_role = 0
        AND NOT u.[sid] IS NULL
        AND NOT u.name IN ('dbo', 'guest', 'public')
        AND NOT r.principal_id = u.principal_id
)

SELECT
    t.principal_type
    , t.principal
    , t.name
    , t.[type]
    , t.has_any
    , t.[VIEW DEFINITION]
    , t.[IMPERSONATE]
    , t.[TAKE OWNERSHIP]
    , t.[ALTER]
    , t.[CONTROL]
FROM
    (
        SELECT
            LOWER(r.type_desc) AS principal_type
            , r.name AS principal
            , u.name AS name
            , LOWER(u.type_desc) AS [type]
            , CASE WHEN COALESCE([VIEW DEFINITION], [IMPERSONATE], [TAKE OWNERSHIP], [ALTER], [CONTROL], 0) = 0 THEN 0 ELSE 1 END AS has_any
            , CASE p.[VIEW DEFINITION]  WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [VIEW DEFINITION]
            , CASE p.[IMPERSONATE]      WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [IMPERSONATE]
            , CASE p.[TAKE OWNERSHIP]   WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [TAKE OWNERSHIP]
            , CASE p.[ALTER]            WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [ALTER]
            , CASE p.[CONTROL]          WHEN 43 THEN 'DENY' WHEN 42 THEN 'GRANT+' WHEN 41 THEN 'GRANT' WHEN 33 THEN 'DENY r' WHEN 32 THEN 'GRANT+ r' WHEN 31 THEN 'GRANT r' ELSE NULL END AS [CONTROL]
        FROM
            (
                SELECT
                    t.principal_id
                    , t.[user_id]
                    , t.[permission_name]
                    , CASE t.[state] WHEN 'D' THEN 43 WHEN 'W' THEN 42 WHEN 'G' THEN 41 ELSE NULL END AS state_mask
                FROM
                    cte t
                UNION ALL
                SELECT
                    u.principal_id
                    , t.[user_id]
                    , t.[permission_name]
                    , CASE t.[state] WHEN 'D' THEN 33 WHEN 'W' THEN 32 WHEN 'G' THEN 31 ELSE NULL END AS state_mask
                FROM
                    cte t
                    INNER JOIN sys.database_role_members rm ON rm.role_principal_id = t.principal_id
                    LEFT OUTER JOIN sys.database_principals u ON u.principal_id = rm.member_principal_id
                WHERE
                    t.[permission_name] IS NOT NULL
            ) s PIVOT (
                MAX(state_mask)
                FOR [permission_name] IN (
                    [VIEW DEFINITION]
                    , [IMPERSONATE]
                    , [TAKE OWNERSHIP], [ALTER], [CONTROL]
                    )
            ) p
            INNER JOIN sys.database_principals r ON r.principal_id = p.principal_id
            INNER JOIN sys.database_principals u ON u.principal_id = p.[user_id]
    ) t
WHERE
    COALESCE(t.principal, '') = COALESCE(@principal, t.principal, '')
    AND COALESCE(t.name, '') = COALESCE(@name, t.name, '')
    AND COALESCE(t.has_any, -1) = COALESCE(@has_any, t.has_any, -1)
ORDER BY
    t.principal_type
    , t.principal
    , t.[type]
    , t.name

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Cell change event handler for usp_object_permissions
-- =============================================

CREATE PROCEDURE [xls].[usp_principal_permissions_change]
    @column_name nvarchar(128) = NULL
    , @cell_value int = NULL
    , @principal nvarchar(128) = NULL
    , @name nvarchar(128) = NULL
    , @type nvarchar(128) = NULL
AS
BEGIN

SET NOCOUNT ON

DECLARE @permission varchar(128)
DECLARE @authorization varchar(128)

SET @permission = UPPER(@column_name)
SET @authorization = UPPER(@cell_value)
DECLARE @options varchar(128) = ''

-- Start from here

SET NOCOUNT ON

IF CHARINDEX('-' + @permission + '-',
    '-VIEW DEFINITION-IMPERSONATE-TAKE OWNERSHIP-ALTER-CONTROL-') = 0
    RETURN

IF @authorization IS NULL
    SET @authorization = 'REVOKE'
ELSE IF @authorization = 'GRANT' OR @authorization = 'G'
    SET @authorization = 'GRANT'
ELSE IF @authorization = 'GRANT+' OR @authorization = 'G+'
    BEGIN
    SET @authorization = 'GRANT'
    SET @options      = ' WITH GRANT OPTION'
    END
ELSE IF @authorization = 'DENY' OR @authorization = 'D'
    SET @authorization = 'DENY'
ELSE IF @authorization = 'DENY+' OR @authorization = 'D+'
    BEGIN
    SET @authorization = 'DENY'
    SET @options      = ' CASCADE'
    END
ELSE IF @authorization = 'REVOKE' OR @authorization = 'R'
    SET @authorization = 'REVOKE'
ELSE IF @authorization = 'REVOKE-' OR @authorization = 'R-'
    SET @authorization = 'REVOKE GRANT OPTION FOR'
ELSE IF @authorization = 'REVOKE+' OR @authorization = 'R+'
    BEGIN
    SET @authorization = 'REVOKE'
    SET @options      = ' CASCADE'
    END
ELSE
    RETURN

DECLARE @query varchar(max)

IF CHARINDEX('user', @type) > 0
    SET @query = @authorization + ' ' + @permission + ' ON USER::' + QUOTENAME(@name) + ' TO ' + QUOTENAME(@principal) + @options
ELSE IF CHARINDEX('application', @type) > 0
    SET @query = @authorization + ' ' + @permission + ' ON APPLICATION ROLE::' + QUOTENAME(@name) + ' TO ' + QUOTENAME(@principal) + @options
ELSE
    SET @query = @authorization + ' ' + @permission + ' ON ROLE::' + QUOTENAME(@name) + ' TO ' + QUOTENAME(@principal) + @options

EXEC (@query)

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Selects user roles
-- =============================================

ALTER PROCEDURE [xls].[usp_role_members]
AS
BEGIN

SET NOCOUNT ON;

DECLARE @list varchar(MAX)

SELECT @list = STUFF((
    SELECT ', [' + name + ']' FROM (
        SELECT DISTINCT p.name, p.is_fixed_role FROM sys.database_principals p
            WHERE name NOT IN ('db_owner', 'public') AND p.[type] IN ('R') AND p.is_fixed_role = 0
        ) AS t ORDER BY t.is_fixed_role, t.name
    FOR XML PATH(''), TYPE
    ).value('.', 'nvarchar(MAX)'), 1, 2, '')

IF @list IS NULL
    SELECT
        LOWER(m.type_desc) AS [type]
        , m.name
        , NULL AS format_column
    FROM
        sys.database_principals m
        LEFT JOIN sys.database_role_members rm ON rm.member_principal_id = m.principal_id
        LEFT JOIN sys.database_principals p ON p.principal_id = rm.role_principal_id
    WHERE
        m.[type] IN ('S', 'U', 'R')
        AND m.is_fixed_role = 0
        AND NOT m.name IN ('dbo', 'sys', 'guest', 'public', 'INFORMATION_SCHEMA', 'xls_users', 'xls_developers', 'xls_formats', 'xls_admins', 'doc_readers', 'doc_writers', 'log_app', 'log_admins', 'log_administrators', 'log_users')
    ORDER BY
        m.type_desc
        , m.name
ELSE
    BEGIN
    DECLARE @sql varchar(MAX)
    SET @sql = '
SELECT
    LOWER(p.[type]) AS [type]
    , p.name
    , NULL AS format_column
    , ' + COALESCE(@list, '') + '
FROM
    (
    SELECT
        p.name AS [role]
        , m.type_desc AS [type]
        , m.name
        , 1 AS [include]
    FROM
        sys.database_principals m
        LEFT JOIN sys.database_role_members rm ON rm.member_principal_id = m.principal_id
        LEFT JOIN sys.database_principals p ON p.principal_id = rm.role_principal_id
    WHERE
        m.[type] IN (''S'', ''U'', ''R'')
        AND m.is_fixed_role = 0
        AND NOT m.name IN (''dbo'', ''sys'', ''guest'', ''public'', ''INFORMATION_SCHEMA'', ''xls_users'', ''xls_developers'', ''xls_formats'', ''xls_admins'', ''doc_readers'', ''doc_writers'', ''log_app'', ''log_admins'', ''log_administrators'', ''log_users'')
    ) s PIVOT (
        SUM([include]) FOR [role] IN ('+ COALESCE(@list, '') + ')
    ) p
ORDER BY
    p.[type]
    , p.[name]
'
    EXEC(@sql)
    -- PRINT @sql
    END

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Cell change event handler for usp_roles
-- =============================================

ALTER PROCEDURE [xls].[usp_role_members_change]
    @column_name nvarchar(128) = NULL
    , @cell_number_value int = NULL
    , @name nvarchar(128) = NULL
    , @data_language char(2) = NULL
AS
BEGIN

SET NOCOUNT ON

DECLARE @message nvarchar(max)

IF DATABASE_PRINCIPAL_ID(@column_name) IS NULL
    BEGIN
    SET @message = N'Role ''%s'' does not exist'
    SET @message = COALESCE((SELECT TOP 1 TRANSLATED_NAME FROM xls.translations WHERE TABLE_SCHEMA = 'xls' AND TABLE_NAME = 'strings' AND LANGUAGE_NAME =  @data_language AND COLUMN_NAME = @message), @message)
    RAISERROR(@message, 11, 0, @column_name);
    RETURN
    END

IF DATABASE_PRINCIPAL_ID(@name) IS NULL
    BEGIN
    SET @message = N'User ''%s'' does not exist'
    SET @message = COALESCE((SELECT TOP 1 TRANSLATED_NAME FROM xls.translations WHERE TABLE_SCHEMA = 'xls' AND TABLE_NAME = 'strings' AND LANGUAGE_NAME =  @data_language AND COLUMN_NAME = @message), @message)
    RAISERROR(@message, 11, 0, @name);
    RETURN
    END

IF @cell_number_value = 0
    EXEC sp_droprolemember @column_name, @name
ELSE IF @cell_number_value = 1
    EXEC sp_addrolemember @column_name, @name
ELSE
    BEGIN
    SET @message = N'Set 1 to add and 0 to remove a user from the role'
    SET @message = COALESCE((SELECT TOP 1 TRANSLATED_NAME FROM xls.translations WHERE TABLE_SCHEMA = 'xls' AND TABLE_NAME = 'strings' AND LANGUAGE_NAME =  @data_language AND COLUMN_NAME = @message), @message)
    RAISERROR(@message, 11, 0);
    RETURN
    END

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: The procedure selects values for the @principal parameter
-- =============================================

CREATE PROCEDURE [xls].[xl_parameter_values_principal]
AS
BEGIN

SET NOCOUNT ON

SELECT NULL AS name UNION ALL
SELECT
    name
FROM
    sys.database_principals r
WHERE
    r.is_fixed_role = 0
    AND NOT r.name IN ('dbo', 'sys', 'public', 'guest', 'INFORMATION_SCHEMA')
ORDER BY
    name

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: The procedure selects values for the @schame parameter
-- =============================================

CREATE PROCEDURE [xls].[xl_parameter_values_schema]
AS
BEGIN

SET NOCOUNT ON

SELECT NULL AS name UNION ALL
SELECT
    s.name
FROM
    sys.schemas s
    INNER JOIN sys.database_principals e ON e.principal_id = s.principal_id
WHERE
    e.is_fixed_role = 0
    AND NOT e.[sid] IS NULL
    AND NOT s.name IN ('sys', 'guest', 'INFORMATION_SCHEMA')
ORDER BY
    name

END


GO

-- =============================================
-- Author:      Gartle LLC
-- Release:     9.5, 2020-01-17
-- Description: Selects translations
-- =============================================

ALTER PROCEDURE [xls].[usp_translations]
    @field nvarchar(128) = NULL
    , @schema nvarchar(128) = NULL
AS
BEGIN

SET NOCOUNT ON;

IF @field IS NULL
    SET @field = 'TRANSLATED_NAME'
ELSE IF @field NOT IN ('TRANSLATED_NAME', 'TRANSLATED_DESC', 'TRANSLATED_COMMENT')
    BEGIN
    DECLARE @message nvarchar(max) = N'Invalid column name: %s' + CHAR(13) + CHAR(10)
         + 'Use TRANSLATED_NAME, TRANSLATED_DESC, or TRANSLATED_COMMENT'
    RAISERROR(@message, 11, 0, @field);
    RETURN
    END

DECLARE @sql nvarchar(max)
DECLARE @languages nvarchar(max)

SELECT @languages = STUFF((
    SELECT
        t.name
    FROM
        (
        SELECT
            DISTINCT
            ', [' + t.LANGUAGE_NAME + ']' AS name
            , CASE
                WHEN t.LANGUAGE_NAME = 'en' THEN '1'
                WHEN t.LANGUAGE_NAME = 'fr' THEN '2'
                WHEN t.LANGUAGE_NAME = 'it' THEN '3'
                WHEN t.LANGUAGE_NAME = 'es' THEN '4'
                ELSE t.LANGUAGE_NAME
                END AS sort_order
        FROM
            xls.translations t
        ) t
    ORDER BY
        t.sort_order
    FOR XML PATH(''), TYPE).value('.', 'nvarchar(MAX)'), 1, 2, '')

IF @languages IS NULL SET @languages = '[en]'

SET @sql = 'SELECT
    t.TABLE_SCHEMA
    , t.TABLE_NAME
    , t.COLUMN_NAME AS [COLUMN]
    , ' + @languages + '
FROM
    (
        SELECT
            t.TABLE_SCHEMA
            , t.TABLE_NAME
            , t.COLUMN_NAME
            , t.LANGUAGE_NAME
            , t.' + @field + ' AS name
        FROM
            xls.translations t
        WHERE
            COALESCE(t.TABLE_SCHEMA, '''') = COALESCE(' + COALESCE('''' + @schema + '''', 'NULL') + ', t.TABLE_SCHEMA, '''')
    ) s PIVOT (
        MAX(name) FOR LANGUAGE_NAME IN (' + @languages + ')
    ) t
ORDER BY
    t.TABLE_SCHEMA
    , t.TABLE_NAME
    , t.COLUMN_NAME'

-- PRINT @sql

EXEC (@sql)

END

GO

DELETE FROM xls.handlers WHERE TABLE_SCHEMA = N'xls' AND TABLE_NAME = N'usp_role_members';
GO

INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_translations', N'schema', N'ParameterValues', N'xls', N'translations', N'TABLE', N'TABLE_SCHEMA', NULL, NULL, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', N'principal', N'ParameterValues', N'xls', N'xl_parameter_values_principal', N'PROCEDURE', NULL, NULL, NULL, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', N'schema', N'ParameterValues', N'xls', N'xl_parameter_values_schema', N'PROCEDURE', NULL, NULL, NULL, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', N'type', N'ParameterValues', N'xls', N'xl_parameter_values_type', N'VALUES', N', schema, table, view, procedure, function', NULL, NULL, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_principal_permissions', N'principal', N'ParameterValues', N'xls', N'xl_parameter_values_principal', N'PROCEDURE', NULL, NULL, NULL, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_principal_permissions', N'name', N'ParameterValues', N'xls', N'xl_parameter_values_principal', N'PROCEDURE', NULL, NULL, NULL, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_database_permissions', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-procedures.htm#xls.usp_database_permissions', NULL, 11, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_database_permissions', NULL, N'Actions', N'xls', N'MenuSeparator20', N'MENUSEPARATOR', NULL, NULL, 20, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_database_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms191291.aspx', NULL, 21, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_database_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - GRANT Database Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms187940.aspx', NULL, 22, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_database_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - DENY Database Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms177518.aspx', NULL, 23, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_database_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - REVOKE Database Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms177573.aspx', NULL, 24, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-procedures.htm#xls.usp_object_permissions', NULL, 11, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'MenuSeparator20', N'MENUSEPARATOR', NULL, NULL, 20, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms191291.aspx', NULL, 21, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - GRANT Schema Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms187940.aspx', NULL, 22, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - GRANT Object Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms188371.aspx', NULL, 23, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - DENY Schema Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms176128.aspx', NULL, 24, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - DENY Object Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms173724.aspx', NULL, 25, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - REVOKE Schema Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms187733.aspx', NULL, 26, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_object_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - REVOKE Object Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms187719.aspx', NULL, 27, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_principal_permissions', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-procedures.htm#xls.usp_principal_permissions', NULL, 11, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_principal_permissions', NULL, N'Actions', N'xls', N'MenuSeparator20', N'MENUSEPARATOR', NULL, NULL, 20, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_principal_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms191291.aspx', NULL, 21, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_principal_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - GRANT Database Principal Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms173848.aspx', NULL, 22, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_principal_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - DENY Database Principal Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms177518.aspx', NULL, 23, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_principal_permissions', NULL, N'Actions', N'xls', N'Transact-SQL Reference - REVOKE Database Principal Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms188356.aspx', NULL, 24, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_role_members', NULL, N'Actions', N'xls', N'SaveToDB Framework Online Help', N'HTTP', N'https://www.savetodb.com/help/savetodb-framework-procedures.htm#xls.usp_role_members', NULL, 11, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_role_members', NULL, N'Actions', N'xls', N'MenuSeparator20', N'MENUSEPARATOR', NULL, NULL, 20, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_role_members', NULL, N'Actions', N'xls', N'Transact-SQL Reference - Permissions', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms191291.aspx', NULL, 21, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_role_members', NULL, N'Actions', N'xls', N'Transact-SQL Reference - CREATE ROLE', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms187936.aspx', NULL, 22, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_role_members', NULL, N'Actions', N'xls', N'Transact-SQL Reference - ALTER ROLE', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms189775.aspx', NULL, 23, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_role_members', NULL, N'Actions', N'xls', N'Transact-SQL Reference - DROP ROLE', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms174988.aspx', NULL, 24, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_role_members', NULL, N'Actions', N'xls', N'Transact-SQL Reference - sp_addrolemember', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms187750.aspx', NULL, 25, NULL);
INSERT INTO xls.handlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES (N'xls', N'usp_role_members', NULL, N'Actions', N'xls', N'Transact-SQL Reference - sp_droprolemember', N'HTTP', N'https://msdn.microsoft.com/en-us/library/ms188369.aspx', NULL, 26, NULL);
GO

CREATE ROLE xls_admins;
GO

GRANT VIEW DEFINITION ON SCHEMA::xls TO xls_admins;

GRANT VIEW DEFINITION ON ROLE::xls_users      TO xls_admins;
GRANT VIEW DEFINITION ON ROLE::xls_formats    TO xls_admins;
GRANT VIEW DEFINITION ON ROLE::xls_developers TO xls_admins;

GRANT SELECT ON xls.formats        TO xls_admins;
GRANT SELECT ON xls.handlers       TO xls_admins;
GRANT SELECT ON xls.objects        TO xls_admins;
GRANT SELECT ON xls.translations   TO xls_admins;
GRANT SELECT ON xls.workbooks      TO xls_admins;
GRANT SELECT ON xls.queries        TO xls_admins;

GRANT EXECUTE ON xls.usp_database_permissions         TO xls_admins;
GRANT EXECUTE ON xls.usp_database_permissions_change  TO xls_admins;
GRANT EXECUTE ON xls.usp_object_permissions           TO xls_admins;
GRANT EXECUTE ON xls.usp_object_permissions_change    TO xls_admins;
GRANT EXECUTE ON xls.usp_principal_permissions        TO xls_admins;
GRANT EXECUTE ON xls.usp_principal_permissions_change TO xls_admins;
GRANT EXECUTE ON xls.usp_role_members                 TO xls_admins;
GRANT EXECUTE ON xls.usp_role_members_change          TO xls_admins;
GRANT EXECUTE ON xls.xl_parameter_values_principal    TO xls_admins;
GRANT EXECUTE ON xls.xl_parameter_values_schema       TO xls_admins;
GO
